Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/TagNames.pod
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/TagNames.pod	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/TagNames.pod	(revision 34921)
@@ -13,10 +13,16 @@
 
 The tables listed below give the names of all tags recognized by ExifTool.
-
-B<Tag ID>, B<Index> or B<Sequence> is given in the first column of each
+They contain a total of 24079 tags, with 15589 unique tag names.
+
+B<Tag ID>, B<Index#> or B<Sequence> is given in the first column of each
 table.  A B<Tag ID> is the computer-readable equivalent of a tag name, and
-is the identifier that is actually stored in the file.  An B<Index> refers
-to the location of a value when found at a fixed position within a data
-block, and B<Sequence> gives the order of values for a serial data stream.
+is the identifier that is actually stored in the file.  B<Index#> refers to
+the offset of a value when found at a fixed position within a data block
+(B<#> is the multiplier for calculating a byte offset: B<1>, B<2>, B<4> or
+B<8>).  These offsets may have a decimal part which is used only to
+differentiate tags with values stored at the same position.  (Note that
+writable tags within binary data blocks are not individually deletable,
+and the usual alternative is to set them to a value of zero.)  B<Sequence>
+gives the order of values for a serial data stream.
 
 A B<Tag Name> is the handle by which the information is accessed in
@@ -32,38 +38,41 @@
 
 The B<Writable> column indicates whether the tag is writable by ExifTool.
-Anything but an C<N> in this column means the tag is writable.  A C<Y>
+Anything but a C<no> in this column means the tag is writable.  A C<yes>
 indicates writable information that is either unformatted or written using
-the existing format.  Other expressions give details about the information
-format, and vary depending on the general type of information.  The format
-name may be followed by a number in square brackets to indicate the number
-of values written, or the number of characters in a fixed-length string
-(including a null terminator which is added if required).
+the existing format.  Other expressions give details about the format of the
+stored value, and vary depending on the general type of information.  The
+format name may be followed by a number in square brackets to indicate the
+number of values written, or the number of characters in a fixed-length
+string (including a null terminator which is added if required).
 
 A plus sign (C<+>) after an entry in the B<Writable> column indicates a
-"list" tag which supports multiple values and allows individual values to be
-added and deleted.  A slash (C</>) indicates an "avoided" tag that is not
-created when writing if another same-named tag may be created instead.  To
-write these tags, the group should be specified.  A tilde (C<~>) indicates a
-tag this is writable only when the print conversion is disabled (by setting
-PrintConv to 0, using the -n option, or suffixing the tag name with a C<#>
-character).  An exclamation point (C<!>) indicates a tag that is considered
-unsafe to write under normal circumstances.  These "unsafe" tags are not set
-when calling SetNewValuesFromFile() or copied with the exiftool
--tagsFromFile option unless specified explicitly, and care should be taken
-when editing them manually since they may affect the way an image is
-rendered.  An asterisk (C<*>) indicates a "protected" tag which is not
+I<List> tag which supports multiple values and allows individual values to
+be added and deleted.  A slash (C</>) indicates a tag that ExifTool will
+I<Avoid> when writing.  These will be edited but not created if another
+same-named tag may be created instead.  To create these tags, the group
+should be specified.  A tilde (C<~>) indicates a tag this is writable only
+when the print conversion is disabled (by setting PrintConv to 0, using the
+-n option, or suffixing the tag name with a C<#> character). An exclamation
+point (C<!>) indicates a tag that is considered I<Unsafe> to write under
+normal circumstances.  These tags are not written unless specified
+explicitly (ie. not when wildcards or "all" are used), and care should be
+taken when editing them manually since they may affect the way an image is
+rendered.  An asterisk (C<*>) indicates a I<Protected> tag which is not
 writable directly, but is written automatically by ExifTool (often when a
-corresponding Composite or Extra tag is written).  A colon (C<:>) indicates
-a mandatory tag which may be added automatically when writing.
+corresponding L<Composite|Image::ExifTool::TagNames/Composite Tags> or
+L<Extra|Image::ExifTool::TagNames/Extra Tags> tag is written). A colon
+(C<:>) indicates a I<Mandatory> tag which may be added automatically when
+writing.  Normally MakerNotes tags may not be deleted individually, but a
+caret (C<^>) indicates a I<Deletable> MakerNotes tag.
 
 The HTML version of these tables also lists possible B<Values> for
 discrete-valued tags, as well as B<Notes> for some tags.  The B<Values> are
-listed as the computer-readable and human-readable values on the left and
-right hand side of an equals sign (C<=>) respectively.  The human-readable
+listed with the computer-readable values on the left of the equals sign
+(C<=>), and the human-readable values on the right.  The human-readable
 values are used by default when reading and writing, but the
 computer-readable values may be accessed by disabling the value conversion
-with the -n option on the command line, by setting the ValueConv option to 0
-in the API, or or on a per-tag basis by appending a number symbol (C<#>) to
-the tag name.
+with the -n option on the command line, by setting the PrintConv option to 0
+in the API, or or on a per-tag basis by adding a hash (C<#>) after the tag
+name.
 
 B<Note>: If you are familiar with common meta-information tag names, you may
@@ -74,7 +83,17 @@
 question.
 
+I<(This documentation is the result of years of research, testing and
+reverse engineering, and is the most complete metadata tag list available
+anywhere on the internet.  It is provided not only for ExifTool users, but
+more importantly as a public service to help augment the collective
+knowledge, and is often used as a primary source of information in the
+development of other metadata software.  Please help keep this documentation
+as accurate and complete as possible, and feed any new discoveries back to
+ExifTool.  A big thanks to everyone who has helped with this so far!)>
+
 =head2 JPEG Tags
 
-This table lists information extracted by ExifTool from JPEG images.
+This table lists information extracted by ExifTool from JPEG images. See
+L<https://www.w3.org/Graphics/JPEG/jfif3.pdf> for the JPEG specification.
 
   Tag ID       Tag Name                         Writable
@@ -89,20 +108,34 @@
                XMP                              XMP
                QVCI                             Casio QVCI
+               FLIR                             FLIR FFF
+               RawThermalImage                  no
   'APP2'       ICC_Profile                      ICC_Profile
                FPXR                             FlashPix
                MPF                              MPF
-               PreviewImage                     N
+               PreviewImage                     no
   'APP3'       Meta                             Kodak Meta
                Stim                             Stim
-               PreviewImage                     N
-  'APP4'       Scalado                          JPEG Scalado
+               ThermalData                      no
+               PreviewImage                     no
+  'APP4'       Scalado                          Scalado
                FPXR                             FlashPix
-               PreviewImage                     N
+               ThermalParams                    DJI ThermalParams
+               PreviewImage                     no
   'APP5'       RMETA                            Ricoh RMETA
+               SamsungUniqueID                  Samsung APP5
+               ThermalCalibration               no
+               PreviewImage                     no
   'APP6'       EPPIM                            JPEG EPPIM
                NITF                             JPEG NITF
                HP_TDHD                          HP TDHD
+               GoPro                            GoPro GPMF
+               DJI_DTAT                         no
+  'APP7'       Pentax                           Pentax
+               Huawei                           Unknown
+               Qualcomm                         Qualcomm
   'APP8'       SPIFF                            JPEG SPIFF
-  'APP10'      Comment                          N
+  'APP9'       MediaJukebox                     JPEG MediaJukebox
+  'APP10'      Comment                          no
+  'APP11'      JPEG-HDR                         JPEG HDR
   'APP12'      PictureInfo                      APP12 PictureInfo
                Ducky                            APP12 Ducky
@@ -111,6 +144,6 @@
   'APP14'      Adobe                            JPEG Adobe
   'APP15'      GraphicConverter                 JPEG GraphConv
-  'COM'        Comment                          Y
-  'DQT'        DefineQuantizationTable          N
+  'COM'        Comment                          yes
+  'DQT'        DefineQuantizationTable          no
   'SOF'        StartOfFrame                     JPEG SOF
   'Trailer'    AFCP                             AFCP
@@ -119,5 +152,8 @@
                PhotoMechanic                    PhotoMechanic
                MIE                              MIE
-               PreviewImage                     Y
+               Samsung                          Samsung Trailer
+               EmbeddedVideo                    no
+               Insta360                         no
+               PreviewImage                     yes
 
 =head3 JPEG AVI1 Tags
@@ -125,7 +161,7 @@
 This information may be found in APP0 of JPEG image data from AVI videos.
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
-      0    InterleavedField                     N
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
+      0    InterleavedField                     no
 
 =head3 JPEG Ocad Tags
@@ -136,17 +172,5 @@
   Tag ID   Tag Name                             Writable
   ------   --------                             --------
-  'Rev'    OcadRevision                         N
-
-=head3 JPEG Scalado Tags
-
-Tags extracted from the JPEG APP4 "SCALADO" segment (presumably written by
-Scalado mobile software, L<http://www.scalado.com/>).
-
-  Tag ID   Tag Name                             Writable
-  ------   --------                             --------
-  'HGHT'   PreviewImageHeight                   N
-  'QUAL'   PreviewQuality                       N
-  'SPMO'   DataLength                           N
-  'WDTH'   PreviewImageWidth                    N
+  'Rev'    OcadRevision                         no
 
 =head3 JPEG EPPIM Tags
@@ -165,18 +189,18 @@
 the official specification.
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
-      0    NITFVersion                          N
-      2    ImageFormat                          N
-      3    BlocksPerRow                         N
-      5    BlocksPerColumn                      N
-      7    ImageColor                           N
-      8    BitDepth                             N
-      9    ImageClass                           N
-     10    JPEGProcess                          N
-     11    Quality                              N
-     12    StreamColor                          N
-     13    StreamBitDepth                       N
-     14    Flags                                N
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
+      0    NITFVersion                          no
+      2    ImageFormat                          no
+      3    BlocksPerRow                         no
+      5    BlocksPerColumn                      no
+      7    ImageColor                           no
+      8    BitDepth                             no
+      9    ImageClass                           no
+     10    JPEGProcess                          no
+     11    Quality                              no
+     12    StreamColor                          no
+     13    StreamBitDepth                       no
+     14    Flags                                no
 
 =head3 JPEG SPIFF Tags
@@ -187,38 +211,72 @@
 specification.
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
-      0    SPIFFVersion                         N
-      2    ProfileID                            N
-      3    ColorComponents                      N
-      6    ImageHeight                          N
-     10    ImageWidth                           N
-     14    ColorSpace                           N
-     15    BitsPerSample                        N
-     16    Compression                          N
-     17    ResolutionUnit                       N
-     18    YResolution                          N
-     22    XResolution                          N
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
+      0    SPIFFVersion                         no
+      2    ProfileID                            no
+      3    ColorComponents                      no
+      6    ImageHeight                          no
+     10    ImageWidth                           no
+     14    ColorSpace                           no
+     15    BitsPerSample                        no
+     16    Compression                          no
+     17    ResolutionUnit                       no
+     18    YResolution                          no
+     22    XResolution                          no
+
+=head3 JPEG MediaJukebox Tags
+
+Tags found in the XML metadata of the APP9 "Media Jukebox" segment.
+
+  Tag Name                                      Writable
+  --------                                      --------
+  Album                                         no
+  Caption                                       no
+  Date                                          no
+  Keywords                                      no
+  Name                                          no
+  People                                        no
+  Places                                        no
+  Tool_Name                                     no
+  Tool_Version                                  no
+
+=head3 JPEG HDR Tags
+
+Information extracted from APP11 of a JPEG-HDR image.
+
+  Tag ID               Tag Name                 Writable
+  ------               --------                 --------
+  'RatioImage'         RatioImage               no
+  'alp'                Alpha                    no
+  'bet'                Beta                     no
+  'cor'                CorrectionMethod         no
+  'ln0'                Ln0                      no
+  'ln1'                Ln1                      no
+  's2n'                S2n                      no
+  'ver'                JPEG-HDRVersion          no
 
 =head3 JPEG AdobeCM Tags
 
-The "Adobe_CM" APP13 segment presumably contains color management
+The APP13 "Adobe_CM" segment presumably contains color management
 information, but the meaning of the data is currently unknown.  If anyone
 has an idea about what this means, please let me know.
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
-      0    AdobeCMType                          N
+  Index2   Tag Name                             Writable
+  ------   --------                             --------
+      0    AdobeCMType                          no
 
 =head3 JPEG Adobe Tags
 
-The "Adobe" APP14 segment stores image encoding information for DCT filters.
-
-   Index   Tag Name                             Writable
-   -----   --------                             --------
-      0    DCTEncodeVersion                     N
-      1    APP14Flags0                          N
-      2    APP14Flags1                          N
-      3    ColorTransform                       N
+The APP14 "Adobe" segment stores image encoding information for DCT filters.
+This segment may be copied or deleted as a block using the Extra "Adobe"
+tag, but note that it is not deleted by default when deleting all metadata
+because it may affect the appearance of the image.
+
+  Index2   Tag Name                             Writable
+  ------   --------                             --------
+      0    DCTEncodeVersion                     no
+      1    APP14Flags0                          no
+      2    APP14Flags1                          no
+      3    ColorTransform                       no
 
 =head3 JPEG GraphConv Tags
@@ -228,5 +286,5 @@
   Tag ID   Tag Name                             Writable
   ------   --------                             --------
-  'Q'      Quality                              N
+  'Q'      Quality                              no
 
 =head3 JPEG SOF Tags
@@ -236,10 +294,10 @@
   Tag Name                                      Writable
   --------                                      --------
-  BitsPerSample                                 N
-  ColorComponents                               N
-  EncodingProcess                               N
-  ImageHeight                                   N
-  ImageWidth                                    N
-  YCbCrSubSampling                              N
+  BitsPerSample                                 no
+  ColorComponents                               no
+  EncodingProcess                               no
+  ImageHeight                                   no
+  ImageWidth                                    no
+  YCbCrSubSampling                              no
 
 =head2 EXIF Tags
@@ -247,6 +305,6 @@
 EXIF stands for "Exchangeable Image File Format".  This type of information
 is formatted according to the TIFF specification, and may be found in JPG,
-TIFF, PNG, PGF, MIFF, HDP, PSP and XCF images, as well as many TIFF-based
-RAW images, and even some AVI and MOV videos.
+TIFF, PNG, JP2, PGF, MIFF, HDP, PSP and XCF images, as well as many
+TIFF-based RAW images, and even some AVI and MOV videos.
 
 The EXIF meta information is organized into different Image File Directories
@@ -255,11 +313,16 @@
 B<Group> listed below is used unless another group is specified.
 
+Mandatory tags (indicated by a colon after the B<Writable> type) may be
+added automatically with default values when creating a new IFD, and the IFD
+is removed automatically when deleting tags if only default-valued mandatory
+tags remain.
+
 The table below lists all EXIF tags.  Also listed are TIFF, DNG, HDP and
 other tags which are not part of the EXIF specification, but may co-exist
-with EXIF tags in some images.  Tags which are part of the EXIF 2.3
+with EXIF tags in some images.  Tags which are part of the EXIF 2.32
 specification have an underlined B<Tag Name> in the HTML version of this
 documentation.  See
-L<http://www.cipa.jp/english/hyoujunka/kikaku/pdf/DC-008-2010_E.pdf> for the
-official EXIF 2.3 specification.
+L<https://web.archive.org/web/20190624045241if_/http://www.cipa.jp:80/std/documents/e/DC-008-Translation-2019-E.pdf>
+for the official EXIF 2.32 specification.
 
   Tag ID   Tag Name                  Group      Writable
@@ -283,14 +346,14 @@
   0x010f   Make                      IFD0       string
   0x0110   Model                     IFD0       string
-  0x0111   StripOffsets              -          N
+  0x0111   StripOffsets              -          no
            PreviewImageStart         IFD0       int32u*
-           PreviewImageStart         SubIFD1    int32u*
+           PreviewImageStart         All        int32u*
            JpgFromRawStart           SubIFD2    int32u*
   0x0112   Orientation               IFD0       int16u
   0x0115   SamplesPerPixel           IFD0       int16u!
   0x0116   RowsPerStrip              IFD0       int32u!
-  0x0117   StripByteCounts           -          N
+  0x0117   StripByteCounts           -          no
            PreviewImageLength        IFD0       int32u*
-           PreviewImageLength        SubIFD1    int32u*
+           PreviewImageLength        All        int32u*
            JpgFromRawLength          SubIFD2    int32u*
   0x0118   MinSampleValue            IFD0       int16u
@@ -302,13 +365,13 @@
   0x011e   XPosition                 IFD0       rational64u
   0x011f   YPosition                 IFD0       rational64u
-  0x0120   FreeOffsets               -          N
-  0x0121   FreeByteCounts            -          N
+  0x0120   FreeOffsets               -          no
+  0x0121   FreeByteCounts            -          no
   0x0122   GrayResponseUnit          IFD0       int16u
-  0x0123   GrayResponseCurve         -          N
-  0x0124   T4Options                 -          N
-  0x0125   T6Options                 -          N
+  0x0123   GrayResponseCurve         -          no
+  0x0124   T4Options                 -          no
+  0x0125   T6Options                 -          no
   0x0128   ResolutionUnit            IFD0       int16u:
   0x0129   PageNumber                IFD0       int16u[2]
-  0x012c   ColorResponseUnit         -          N
+  0x012c   ColorResponseUnit         -          no
   0x012d   TransferFunction          IFD0       int16u[768]!
   0x0131   Software                  IFD0       string
@@ -319,42 +382,42 @@
   0x013e   WhitePoint                IFD0       rational64u[2]
   0x013f   PrimaryChromaticities     IFD0       rational64u[6]
-  0x0140   ColorMap                  -          N
+  0x0140   ColorMap                  -          no
   0x0141   HalftoneHints             IFD0       int16u[2]
   0x0142   TileWidth                 IFD0       int32u!
   0x0143   TileLength                IFD0       int32u!
-  0x0144   TileOffsets               -          N
-  0x0145   TileByteCounts            -          N
-  0x0146   BadFaxLines               -          N
-  0x0147   CleanFaxData              -          N
-  0x0148   ConsecutiveBadFaxLines    -          N
+  0x0144   TileOffsets               -          no
+  0x0145   TileByteCounts            -          no
+  0x0146   BadFaxLines               -          no
+  0x0147   CleanFaxData              -          no
+  0x0148   ConsecutiveBadFaxLines    -          no
   0x014a   SubIFD                    -          EXIF
-           A100DataOffset            -          N
+           A100DataOffset            IFD0       no
   0x014c   InkSet                    IFD0       int16u
-  0x014d   InkNames                  -          N
-  0x014e   NumberofInks              -          N
-  0x0150   DotRange                  IFD0       string
-  0x0151   TargetPrinter             -          N
-  0x0152   ExtraSamples              -          N
-  0x0153   SampleFormat              -          N
-  0x0154   SMinSampleValue           -          N
-  0x0155   SMaxSampleValue           -          N
-  0x0156   TransferRange             -          N
-  0x0157   ClipPath                  -          N
-  0x0158   XClipPathUnits            -          N
-  0x0159   YClipPathUnits            -          N
-  0x015a   Indexed                   -          N
-  0x015b   JPEGTables                -          N
-  0x015f   OPIProxy                  -          N
+  0x014d   InkNames                  -          no
+  0x014e   NumberofInks              -          no
+  0x0150   DotRange                  -          no
+  0x0151   TargetPrinter             IFD0       string
+  0x0152   ExtraSamples              -          no
+  0x0153   SampleFormat              SubIFD     no
+  0x0154   SMinSampleValue           -          no
+  0x0155   SMaxSampleValue           -          no
+  0x0156   TransferRange             -          no
+  0x0157   ClipPath                  -          no
+  0x0158   XClipPathUnits            -          no
+  0x0159   YClipPathUnits            -          no
+  0x015a   Indexed                   -          no
+  0x015b   JPEGTables                -          no
+  0x015f   OPIProxy                  -          no
   0x0190   GlobalParametersIFD       -          EXIF
-  0x0191   ProfileType               -          N
-  0x0192   FaxProfile                -          N
-  0x0193   CodingMethods             -          N
-  0x0194   VersionYear               -          N
-  0x0195   ModeNumber                -          N
-  0x01b1   Decode                    -          N
-  0x01b2   DefaultImageColor         -          N
-  0x01b3   T82Options                -          N
-  0x01b5   JPEGTables                -          N
-  0x0200   JPEGProc                  -          N
+  0x0191   ProfileType               -          no
+  0x0192   FaxProfile                -          no
+  0x0193   CodingMethods             -          no
+  0x0194   VersionYear               -          no
+  0x0195   ModeNumber                -          no
+  0x01b1   Decode                    -          no
+  0x01b2   DefaultImageColor         -          no
+  0x01b3   T82Options                -          no
+  0x01b5   JPEGTables                -          no
+  0x0200   JPEGProc                  -          no
   0x0201   ThumbnailOffset           IFD1       int32u*
            ThumbnailOffset           IFD0       int32u*
@@ -364,5 +427,7 @@
            JpgFromRawStart           SubIFD     int32u*
            JpgFromRawStart           IFD2       int32u*
-           OtherImageStart           -          N
+           OtherImageStart           SubIFD1    int32u*
+           OtherImageStart           SubIFD2    int32u*
+           OtherImageStart           -          no
   0x0202   ThumbnailLength           IFD1       int32u*
            ThumbnailLength           IFD0       int32u*
